*+--------------------------------------------------------------------
*+
*+ Source Module => d:\ALASKA\PDF\\DEMO.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Procedure Appsys()
*+               Procedure Main()
*+               Procedure LoadStart()
*+               Function Pathonly()
*+               Function Fileonly()
*+               Procedure DoResize()
*+
*+    Reformatted by Click! 2.05.30 on Mar-7-2020 at  3:40 am
*+
*+--------------------------------------------------------------------

#include "Xbp.ch"
#include "Appevent.ch"

// #include "ot4xb.ch"

#pragma library("XppUi2")

*+--------------------------------------------------------------------
*+
*+    Procedure Appsys()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Appsys

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure Main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Main

LOCAL nEvent, mp1, mp2, oXbp
LOCAL oDlg, oBtn, oDraw, aDraw
LOCAL lExit  := .F.

   oDlg := XbpDialog() :new(,, { 0, 0 }, { 320, 240 } )
   oDlg:title := "SumatraPDF Demo for Xbase++"
   oDlg:taskList := .T.
   oDlg:close := { || lExit := .T. }
   oDlg:create()
   CenterControl( oDlg )

   oDraw := oDlg:DrawingArea
   aDraw := oDraw:CurrentSize()

   oBtn := XbpPushButton() :new( oDraw,, { 0, 0 }, aDraw )
   oBtn:caption := "Load PDF"
   oBtn:create()
   oBtn:activate := { || oBtn:hide(), LoadStart(), oBtn:show() }

   SetAppfocus( oBtn )
   nEvent := 0
   DO WHILE !lExit
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure LoadStart()
*+
*+    Called from ( demo.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE LoadStart()

LOCAL nEvent, mp1, mp2, oXbp
LOCAL oFileDlg, cPdfFile := ""
LOCAL oPanel, cPanel
LOCAL oSumatra
LOCAL lExit      := .F.
LOCAL cLang      := "de"      // <- change to "en", "es" etc.
LOCAL nPage      := 1
LOCAL nZoom      := 1
LOCAL nView      := 1
LOCAL lBookmarks := .F.
LOCAL lToolbar   := .F.
LOCAL aFilters   := { { "PDF Files", "*.PDF" }, ;
                       { "all Files", "*.*" } }

   oFileDlg := XbpFileDialog() :new()
   oFileDlg:create( AppDesktop() )
   oFileDlg:fileFilters := aFilters

   cPdfFile := oFileDlg:open()

   IF !EMPTY( cPdfFile )

      cPanel := Fileonly( cPdfFile )

      oPanel := XbpDialog() :new(,, { 0, 0 }, { 1280, 1024 } )
      oPanel:title := cPanel
      oPanel:taskList := .T.
      oPanel:close := { || lExit := .T. }
      oPanel:resize := { | aOldSize, aNewSize, oSelf | DoResize( aOldSize, aNewSize, oPanel, oSumatra ) }
      oPanel:create()

      CenterControl( oPanel )

      oSumatra := SumatraPDF() :New( oPanel )
      oSumatra:FileOpen( cPdfFile, nPage, nZoom, nView, lBookmarks, lToolbar, cLang )

      SetAppfocus( oPanel )

      nEvent := 0
      DO WHILE !lExit
         nEvent := AppEvent( @mp1, @mp2, @oXbp )
         oXbp:handleEvent( nEvent, mp1, mp2 )
      ENDDO

      oSumatra:FileClose()
      oPanel:Destroy()

   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Function Pathonly()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Pathonly( cFull )

LOCAL cRet  := ""
LOCAL nPosi

   nPosi := RAT( "\", cFull )
   IF nPosi > 0
      cRet := SUBSTR( cFull, 1, nPosi )
   ENDIF

RETURN cRet

*+--------------------------------------------------------------------
*+
*+    Function Fileonly()
*+
*+    Called from ( demo.prg )   1 - procedure loadstart()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Fileonly( cFull )

LOCAL cRet  := ""
LOCAL nPosi

   nPosi := RAT( "\", cFull )
   IF nPosi > 0
      cRet := SUBSTR( cFull, nPosi + 1 )
   ENDIF

RETURN cRet

*+--------------------------------------------------------------------
*+
*+    Procedure DoResize()
*+
*+    Called from ( demo.prg )   1 - procedure loadstart()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DoResize( aOldSize, aNewSize, oPanel, oSumatra )

LOCAL aSize
   aSize := oPanel:ClientSize
   oSumatra:FrameAdjust( aSize )
RETURN

//
//
//

*+ EOF: DEMO.PRG
